from dbapi.common import *
from dbapi.generic import generic_connect, Connection as GenericConnection, Cursor as GenericCursor, _add_from_python_mapping, _from_python, _add_to_python_mapping, _to_python

assembly = 'System.Data.SQLite'
connection_type = 'System.Data.SQLite.SQLiteConnection'

threadafety = 0
paramstyle = 'qmark'

PARSE_DECLTYPES = 1
PARSE_COLNAMES = 2

register_converter = _add_to_python_mapping
register_adapter = _add_from_python_mapping

def connect(connstr=None, database=None, **kwargs):
    if connstr:
        args = connstr
    else:
        args = {'Data Source': database}
    
    return generic_connect(assembly, connection_type, args, factory=Connection)

class Connection(GenericConnection):
    def __init__(self, connection):
        GenericConnection.__init__(self, connection)
    
    def create_function(self, *args):
        pass
    
    def cursor(self, factory=None, *args, **kwargs):
        return GenericConnection.cursor(self, factory=factory or Cursor, *args, **kwargs)

class Cursor(GenericCursor):
    def __init__(self, connection):
        GenericCursor.__init__(self, connection)
        self.lastrowid = None

    def fetchone(self):
        r = GenericCursor.fetchone(self)
        return tuple(_to_python(v) for v in r)
    
    def fetchmany(self, size=None):
        result = GenericCursor.fetchmany(self, size)
        return [tuple(_to_python(v) for v in r) for r in result]
        
    def fetchall(self):
        result = GenericCursor.fetchall(self)
        return [tuple(_to_python(v) for v in r) for r in result]
